.586P
.8087
;include mmx.inc

;Warning: IN THIS FILE, ALL SEGMENTS ARE REMOVED.  THIS MEANS THAT DS:[]
;MUST BE ADDED FOR ALL SELF-MODIFIES FOR MASM TO WORK.
;
;HUGE BUG IN WASM DISCOVERED!
;An immediate offset is ignored if it is inside brackets with a "*"
;   In other words, this:
;mov eax, dword ptr _buf[eax*4+17]
;   must be re-written as this for WASM to compile properly:
;mov eax, dword ptr _buf+17[eax*4]
;
;MASM PROBLEMS:
;   1. Requires DS: to be written out for self-modifying code to work
;   2. Doesn't encode short jumps automatically like WASM
;   3. Stupidly adds wait prefix to ffree's

EXTRN _uubuf : near
EXTRN _uibuf : near
EXTRN _ubuf : near
EXTRN _fgdxx : dword
EXTRN _fguxx : dword
EXTRN _fgvxx : dword

CODE SEGMENT PUBLIC USE32 'CODE'
ASSUME cs:CODE,ds:CODE

ALIGN 16
doratiojmptable:
	dd beg0_8
	dd beg1_8
	dd beg2_8
	dd beg3_8
	dd beg4_8
	dd beg5_8
	dd beg6_8
	dd beg7_8
	dd beg8_8
	dd beg7_8
	dd beg6_8
	dd beg5_8
	dd beg4_8
	dd beg3_8
	dd beg2_8
	dd beg1_8
espbak: dd 0
asm1: dd 0
asm2: dd 0
num1048576: dd 49800000h

	;al: xbits
	;ah: ybits
	;ebx: bufplc
PUBLIC setupkspin_
setupkspin_:
	mov dword ptr [kspinbuf0-4], ebx
	mov dword ptr [kspinbuf1-4], ebx
	mov dword ptr [kspinbuf2-4], ebx
	mov dword ptr [kspinbuf3-4], ebx
	mov dword ptr [kspinbuf4-4], ebx
	mov dword ptr [kspinbuf5-4], ebx
	mov dword ptr [kspinbuf6-4], ebx
	mov dword ptr [kspinbuf7-4], ebx
	mov dword ptr [kspinbuf8-4], ebx

	mov byte ptr [kspinybits0-1], ah
	mov byte ptr [kspinybits1-1], ah
	mov byte ptr [kspinybits2-1], ah
	mov byte ptr [kspinybits3-1], ah
	mov byte ptr [kspinybits4-1], ah

	xor ebx, ebx
	sub bl, ah
	mov byte ptr [kspinshy1-1], bl
	mov byte ptr [kspinshy2-1], bl
	mov byte ptr [kspinshy3-1], bl
	mov byte ptr [kspinshy4-1], bl
	mov byte ptr [kspinshy5-1], bl
	mov byte ptr [kspinshy6-1], bl
	mov byte ptr [kspinshy7-1], bl
	mov byte ptr [kspinshy8-1], bl
	mov byte ptr [kspinshy9-1], bl
	sub bl, al
	mov byte ptr [kspinshx1-1], bl
	mov byte ptr [kspinshx2-1], bl
	mov byte ptr [kspinshx3-1], bl
	mov byte ptr [kspinshx4-1], bl
	mov byte ptr [kspinshx5-1], bl
	mov byte ptr [kspinshx6-1], bl
	mov byte ptr [kspinshx7-1], bl
	mov byte ptr [kspinshx8-1], bl
	mov byte ptr [kspinshx9-1], bl

	lea ecx, [eax-3]
	mov ebx, 0ffffffffh
	shr ebx, cl
	mov dword ptr [kspinorb0-4], ebx
	mov dword ptr [kspinorb1-4], ebx
	mov dword ptr [kspinorb2-4], ebx
	mov dword ptr [kspinanda3-4], ebx
	mov dword ptr [kspinorb4-4], ebx
	xor ebx, 0ffffffffh
	mov dword ptr [kspinora0-4], ebx
	mov dword ptr [kspinora1-4], ebx
	mov dword ptr [kspinora2-4], ebx
	mov dword ptr [kspinandb3-4], ebx
	mov dword ptr [kspinora4-4], ebx

	add cl, ah
	mov eax, 0ffffffffh
	shr eax, cl
	add eax, ebx
	mov dword ptr [kspinand1-4], eax
	mov dword ptr [kspinand2-4], eax
	mov dword ptr [kspinand3-4], eax
	mov dword ptr [kspinand4-4], eax
	mov dword ptr [kspinand5-4], eax
	mov dword ptr [kspinand6-4], eax
	mov dword ptr [kspinand7-4], eax
	mov dword ptr [kspinand8-4], eax
	mov dword ptr [kspinand9-4], eax
	mov dword ptr [kspinand10-4], eax
	ret

	;     Pass:             Use:
	;eax: cnt               xplc2
	;ebx: ?                 xinc
	;ecx: incptr            dat dat dat dat
	;edx: videoplc          yplc2
	;esi: xplc              xplc
	;edi: yplc              yplc
	;ebp: ?                 yinc
	;esp: ?                 videoplc/cnt
PUBLIC kspin_
kspin_:
	sub eax, 4
	jc dontspin
	push ebp
	mov dword ptr [espbak], esp

		;Self-modifying code
	sub edx, esp
	mov ebp, esp
	sub edx, 4
	sub ebp, eax
	mov dword ptr [kspinwrite0-4], edx
	mov dword ptr [kspinwrite1-4], edx
	lea eax, [ecx-4]
	mov dword ptr [kspinwrite2-4], edx
	sub eax, esp
	mov dword ptr [kspincmp-4], ebp
	mov dword ptr [kspinincoffs-4], eax

		;Reorder xplc for strips
	mov eax, esi
	or esi, 0f8000000h
kspinora0:
	sar esi, 8
kspinybits0:
	or eax, 07ffffffh
kspinorb0:
	and esi, eax

		;Reorder xinc for strips
	mov ebx, [ecx]
	and esi, 0f807ffffh
kspinand9:
	mov eax, [ecx+8]
	sub ebx, eax
	mov eax, [ecx+12]
	mov ebp, ebx
	or ebx, 0f8000000h
kspinora1:
	sar ebx, 8
kspinybits1:
	or ebp, 07ffffffh
kspinorb1:
	and ebx, ebp
	mov ebp, [ecx+4]
	sub ebp, eax

	jmp short kspinbeg

	;The big 8 pixel loop...
ALIGN 16
kspinpbeg:
	mov ebx, dword ptr [ebp+0]
	mov eax, dword ptr [ebp+8]
	sub ebx, eax
	mov edx, dword ptr [ebp+12]
	mov eax, ebx
	or ebx, 0f8000000h
kspinora2:
	sar ebx, 8
kspinybits2:
	or eax, 07ffffffh
kspinorb2:
	and ebx, eax
	mov ebp, dword ptr [ebp+4]
	mov dword ptr [esp+88888888h], ecx
kspinwrite0:
	sub ebp, edx
	sub esp, 4
kspinbeg:
	lea eax, [esi+ebx]
	shr esi, 16
kspinshx1:
	lea edx, [edi+ebp]
	shr edi, 24
kspinshy1:
	and eax, 0f807ffffh
kspinand1:
	mov ch, byte ptr [esi+edi*8+88888888h]
kspinbuf1:
	lea esi, [eax+ebx]
	shr eax, 16
kspinshx2:
	lea edi, [edx+ebp]
	shr edx, 24
kspinshy2:
	and esi, 0f807ffffh
kspinand2:
	mov cl, byte ptr [eax+edx*8+88888888h]
kspinbuf2:
	lea eax, [esi+ebx]
	shr esi, 16
kspinshx3:
	lea edx, [edi+ebp]
	shr edi, 24
kspinshy3:
	and eax, 0f807ffffh
kspinand3:
	shl ecx, 16
	mov ch, byte ptr [esi+edi*8+88888888h]
kspinbuf3:
	lea esi, [eax+ebx]
	shr eax, 16
kspinshx4:
	lea edi, [edx+ebp]
	shr edx, 24
kspinshy4:
	and esi, 0f807ffffh
kspinand4:

	;2nd 4 pixels...

	mov cl, byte ptr [eax+edx*8+88888888h]
kspinbuf4:
	lea eax, [esi+ebx]
	shr esi, 16
kspinshx5:
	lea edx, [edi+ebp]
	shr edi, 24
kspinshy5:
	and eax, 0f807ffffh
kspinand5:
	mov dword ptr [esp+88888888h], ecx
kspinwrite2:
	sub esp, 4
	mov ch, byte ptr [esi+edi*8+88888888h]
kspinbuf5:
	lea esi, [eax+ebx]
	shr eax, 16
kspinshx6:
	lea edi, [edx+ebp]
	shr edx, 24
kspinshy6:
	and esi, 0f807ffffh
kspinand6:
	mov cl, byte ptr [eax+edx*8+88888888h]
kspinbuf6:
	lea eax, [esi+ebx]
	shr esi, 16
kspinshx7:
	lea edx, [edi+ebp]
	shr edi, 24
kspinshy7:
	and eax, 0f807ffffh
kspinand7:
	shl ecx, 16
	mov ch, byte ptr [esi+edi*8+88888888h]
kspinbuf7:
	lea esi, [eax+ebx]
	shr eax, 16
kspinshx8:
	lea edi, [edx+ebp]
	shr edx, 24
kspinshy8:
	and esi, 0f807ffffh
kspinand8:
	lea ebp, [esp+88888888h]
kspinincoffs:
	cmp esp, 88888888h
kspincmp:
	mov cl, byte ptr [eax+edx*8+88888888h]
kspinbuf0:
	ja kspinpbeg

		;Finish off last write / Cleanup registers
	mov dword ptr [esp+88888888h], ecx
kspinwrite1:
	mov esp, dword ptr [espbak]
	pop ebp
dontspin:
	ret

;                                             jmp short 6.5:
;  0: mov ebx, [ebp+0]                        mov eax, [ebp+4]
;  1: sub ebx, eax                            mov edx, [ebp+12]
;  2: mov eax, ebx                            or ebx, 0xf8000000
;  3: sar ebx, 8                              or eax, 0x07ffffff
;  4: and ebx, eax                            mov ebp, [ebp+8]
;  5: mov dword ptr [esp+88888888h], ecx      sub ebp, edx
;  6: sub esp, 4                              lea eax, [esi+ebx]
;  7: shr esi, 16                             lea edx, [edi+ebp]
;  8: shr edi, 24                             and eax, 0f807ffffh
;  9: ;(                                      ;(
; 10: mov ch, byte ptr [esi+edi*8+88888888h]  lea esi, [eax+ebx]
; 11: shr eax, 16                             lea edi, [edx+ebp]
; 12: shr edx, 24                             and esi, 0f807ffffh
; 13: ;(                                      ;(
; 14: mov cl, byte ptr [eax+edx*8+88888888h]  lea eax, [esi+ebx]
; 15: shr esi, 16                             lea edx, [edi+ebp]
; 16: shr edi, 24                             and eax, 0f807ffffh
; 17: shl ecx, 16                             ;(
; 18: mov ch, byte ptr [esi+edi*8+88888888h]  lea esi, [eax+ebx]
; 19: shr eax, 16                             lea edi, [edx+ebp]
; 20: shr edx, 24                             and esi, 0f807ffffh
; 21: ;(                                      ;(
; 22: mov cl, byte ptr [eax+edx*8+88888888h]  lea eax, [esi+ebx]
; 23: shr esi, 16                             lea edx, [edi+ebp]
; 24: shr edi, 24                             and eax, 0f807ffffh
; 25: mov dword ptr [esp+88888888h], ecx      sub esp, 4
; 26: mov ch, byte ptr [esi+edi*8+88888888h]  lea esi, [eax+ebx]
; 27: shr eax, 16                             lea edi, [edx+ebp]
; 28: shr edx, 24                             and esi, 0f807ffffh
; 29: ;(                                      ;(
; 30: mov cl, byte ptr [eax+edx*8+88888888h]  lea eax, [esi+ebx]
; 31: shr esi, 16                             lea edx, [edi+ebp]
; 32: shr edi, 24                             and eax, 0f807ffffh
; 33: shl ecx, 16                             ;(
; 34: mov ch, byte ptr [esi+edi*8+88888888h]  lea esi, [eax+ebx]
; 35: shr eax, 16                             lea edi, [edx+ebp]
; 36: shr edx, 24                             and esi, 0f807ffffh
; 37: lea ebp, [esp+88888888h]                cmp esp, 88888888h
; 38: mov cl, byte ptr [eax+edx*8+88888888h]  ja short 0:
;     mov dword ptr [esp+88888888h], ecx      ;(


	;     Pass:             Use:
	;eax: cnt               tempvar1
	;ebx: xinc              xinc
	;ecx: yinc              yinc
	;edx: videoplc          tempvar2
	;esi: xplc              xplc
	;edi: yplc              yplc
	;ebp: ?                 videoplc/cnt
PUBLIC kspinshort_
kspinshort_:
	push ebp

	sub edx, eax
	inc edx
	mov dword ptr [kspinwriteshort-4], edx

		;Reorder xplc for strips
	mov ebp, esi
	and esi, 7fffffffh
kspinanda3:
	shr esi, 8
kspinybits3:
	and ebp, 0f8000000h
kspinandb3:
	add esi, ebp

		;Reorder xinc for strips
	mov edx, ebx
	or ebx, 0f8000000h
kspinora4:
	sar ebx, 8
kspinybits4:
	or edx, 07ffffffh
kspinorb4:
	and ebx, edx

	jmp short kspinbegshort
ALIGN 16
kspinbegshort:
	mov ebp, esi
	add esi, ebx
	shr ebp, 16
kspinshx9:
	mov edx, edi
	shr edx, 24
kspinshy9:
	and esi, 0f807ffffh
kspinand10:
	dec eax
	lea edi, [edi+ecx]
	mov dl, byte ptr [ebp+edx*8+88888888h]
kspinbuf8:
	mov byte ptr [eax+88888888h], dl
kspinwriteshort:
	jnz short kspinbegshort

	pop ebp
	ret





	;al: xbits
	;ah: ybits
	;ebx: bufplc
PUBLIC prosetupkspin_
prosetupkspin_:
	mov dword ptr [prokspinbuf0-4], ebx
	mov dword ptr [prokspinbuf1-4], ebx
	mov dword ptr [prokspinbuf2-4], ebx
	mov dword ptr [prokspinbuf3-4], ebx
	mov dword ptr [prokspinbuf4-4], ebx
	mov dword ptr [prokspinbuf5-4], ebx
	mov dword ptr [prokspinbuf6-4], ebx
	mov dword ptr [prokspinbuf7-4], ebx
	mov dword ptr [prokspinbuf8-4], ebx

	mov byte ptr [prokspinybits0-1], ah
	mov byte ptr [prokspinybits1-1], ah
	mov byte ptr [prokspinybits2-1], ah
	mov byte ptr [prokspinybits3-1], ah
	mov byte ptr [prokspinybits4-1], ah

	xor ebx, ebx
	sub bl, ah
	mov byte ptr [prokspinshy1-1], bl
	mov byte ptr [prokspinshy2-1], bl
	mov byte ptr [prokspinshy3-1], bl
	mov byte ptr [prokspinshy4-1], bl
	mov byte ptr [prokspinshy5-1], bl
	mov byte ptr [prokspinshy6-1], bl
	mov byte ptr [prokspinshy7-1], bl
	mov byte ptr [prokspinshy8-1], bl
	mov byte ptr [prokspinshy9-1], bl
	sub bl, al
	mov byte ptr [prokspinshx1-1], bl
	mov byte ptr [prokspinshx2-1], bl
	mov byte ptr [prokspinshx3-1], bl
	mov byte ptr [prokspinshx4-1], bl
	mov byte ptr [prokspinshx5-1], bl
	mov byte ptr [prokspinshx6-1], bl
	mov byte ptr [prokspinshx7-1], bl
	mov byte ptr [prokspinshx8-1], bl
	mov byte ptr [prokspinshx9-1], bl

	lea ecx, [eax-3]
	mov ebx, 0ffffffffh
	shr ebx, cl
	mov dword ptr [prokspinorb0-4], ebx
	mov dword ptr [prokspinorb1-4], ebx
	mov dword ptr [prokspinorb2-4], ebx
	mov dword ptr [prokspinanda3-4], ebx
	mov dword ptr [prokspinorb4-4], ebx
	xor ebx, 0ffffffffh
	mov dword ptr [prokspinora0-4], ebx
	mov dword ptr [prokspinora1-4], ebx
	mov dword ptr [prokspinora2-4], ebx
	mov dword ptr [prokspinandb3-4], ebx
	mov dword ptr [prokspinora4-4], ebx

	add cl, ah
	mov eax, 0ffffffffh
	shr eax, cl
	add eax, ebx
	mov dword ptr [prokspinand1-4], eax
	mov dword ptr [prokspinand2-4], eax
	mov dword ptr [prokspinand3-4], eax
	mov dword ptr [prokspinand4-4], eax
	mov dword ptr [prokspinand5-4], eax
	mov dword ptr [prokspinand6-4], eax
	mov dword ptr [prokspinand7-4], eax
	mov dword ptr [prokspinand8-4], eax
	mov dword ptr [prokspinand9-4], eax
	mov dword ptr [prokspinand10-4], eax
	ret


	;     Pass:             Use: (prokspin different from kspin)
	;eax: cnt               xplc2
	;ebx: ?                 xinc
	;ecx: incptr            xplc
	;edx: videoplc          videoplc/cnt
	;esi: xplc              yplc2
	;edi: yplc              yplc
	;ebp: ?                 yinc
	;esp: ?
PUBLIC prokspin_
prokspin_:
	sub eax, 4
	jc prodontspin
	push ebp

	lea ebp, [edx+4]
	sub ebp, eax
	mov [asm1], ebp
	lea ebp, [ecx-8]
	sub ebp, edx
	mov [asm2], ebp

		;Reorder xinc for strips
	mov ebx, [ecx]
	mov eax, [ecx+8]
	sub ebx, eax
	mov eax, [ecx+12]
	mov ebp, ebx
	or ebx, 0f8000000h
prokspinora1:
	sar ebx, 8
prokspinybits1:
	or ebp, 07ffffffh
prokspinorb1:
	and ebx, ebp
	mov ebp, [ecx+4]
	sub ebp, eax

		;Reorder xplc for strips
	mov ecx, esi
	or esi, 0f8000000h
prokspinora0:
	sar esi, 8
prokspinybits0:
	or ecx, 07ffffffh
prokspinorb0:
	and ecx, esi
	and ecx, 0f807ffffh
prokspinand9:

	jmp short prokspinbeg

	;The big 8 pixel loop...
prokspinpbeg:
	mov ebx, dword ptr [ebp+0]
	sub ebx, dword ptr [ebp+8]
	mov esi, dword ptr [ebp+12]
	mov eax, ebx
	or ebx, 0f8000000h
prokspinora2:
	sar ebx, 8
prokspinybits2:
	or eax, 07ffffffh
prokspinorb2:
	and ebx, eax
	mov ebp, dword ptr [ebp+4]
	sub ebp, esi
	sub edx, 8
prokspinbeg:
	lea eax, [ecx+ebx]
	shr ecx, 16
prokspinshx1:
	lea esi, [edi+ebp]
	shr edi, 24
prokspinshy1:
	and eax, 0f807ffffh
prokspinand1:
	mov cl, byte ptr [ecx+edi*8+88888888h]
prokspinbuf1:
	mov byte ptr [edx-1], cl
	lea ecx, [eax+ebx]
	shr eax, 16
prokspinshx2:
	lea edi, [esi+ebp]
	shr esi, 24
prokspinshy2:
	and ecx, 0f807ffffh
prokspinand2:
	mov al, byte ptr [eax+esi*8+88888888h]
prokspinbuf2:
	mov byte ptr [edx-2], al
	lea eax, [ecx+ebx]
	shr ecx, 16
prokspinshx3:
	lea esi, [edi+ebp]
	shr edi, 24
prokspinshy3:
	and eax, 0f807ffffh
prokspinand3:
	mov cl, byte ptr [ecx+edi*8+88888888h]
prokspinbuf3:
	mov byte ptr [edx-3], cl
	lea ecx, [eax+ebx]
	shr eax, 16
prokspinshx4:
	lea edi, [esi+ebp]
	shr esi, 24
prokspinshy4:
	and ecx, 0f807ffffh
prokspinand4:

	;2nd 4 pixels...

	mov al, byte ptr [eax+esi*8+88888888h]
prokspinbuf4:
	mov byte ptr [edx-4], al
	lea eax, [ecx+ebx]
	shr ecx, 16
prokspinshx5:
	lea esi, [edi+ebp]
	shr edi, 24
prokspinshy5:
	and eax, 0f807ffffh
prokspinand5:
	mov cl, byte ptr [ecx+edi*8+88888888h]
prokspinbuf5:
	mov byte ptr [edx-5], cl
	lea ecx, [eax+ebx]
	shr eax, 16
prokspinshx6:
	lea edi, [esi+ebp]
	shr esi, 24
prokspinshy6:
	and ecx, 0f807ffffh
prokspinand6:
	mov al, byte ptr [eax+esi*8+88888888h]
prokspinbuf6:
	mov byte ptr [edx-6], al
	lea eax, [ecx+ebx]
	shr ecx, 16
prokspinshx7:
	lea esi, [edi+ebp]
	shr edi, 24
prokspinshy7:
	and eax, 0f807ffffh
prokspinand7:
	mov cl, byte ptr [ecx+edi*8+88888888h]
prokspinbuf7:
	mov byte ptr [edx-7], cl
	lea ecx, [eax+ebx]
	shr eax, 16
prokspinshx8:
	lea edi, [esi+ebp]
	shr esi, 24
prokspinshy8:
	and ecx, 0f807ffffh
prokspinand8:
	mov ebp, [asm2]
	add ebp, edx
	cmp edx, [asm1]
	mov al, byte ptr [eax+esi*8+88888888h]
prokspinbuf0:
	mov byte ptr [edx-8], al
	jg prokspinpbeg

	pop ebp
prodontspin:
	ret

PUBLIC prokspinshort_
prokspinshort_:
	push ebp

	sub edx, eax
	inc edx
	mov [asm1], edx

		;Reorder xplc for strips
	mov ebp, esi
	and esi, 7fffffffh
prokspinanda3:
	shr esi, 8
prokspinybits3:
	and ebp, 0f8000000h
prokspinandb3:
	add esi, ebp

		;Reorder xinc for strips
	mov edx, ebx
	or ebx, 0f8000000h
prokspinora4:
	sar ebx, 8
prokspinybits4:
	or edx, 07ffffffh
prokspinorb4:
	and ebx, edx

prokspinbegshort:
	mov ebp, esi
	add esi, ebx
	shr ebp, 16
prokspinshx9:
	mov edx, edi
	shr edx, 24
prokspinshy9:
	and esi, 0f807ffffh
prokspinand10:
	dec eax
	lea edi, [edi+ecx]
	mov dl, byte ptr [ebp+edx*8+88888888h]
prokspinbuf8:
	mov ebp, [asm1]
	mov byte ptr [ebp+eax], dl
	jnz short prokspinbegshort

	pop ebp
	ret


	;eax: 0-8 (routine #)
	;esi: x*BOXSIZ
	;edi: cnt
PUBLIC doratio_
doratio_:
	jmp dword ptr doratiojmptable[eax*4]


ALIGN 16
beg0_8:
	mov eax, dword ptr _uubuf[esi]
	shl eax, 3
	mov ecx, dword ptr _uubuf[esi+4]
	shl ecx, 3
	mov dword ptr _ubuf[esi], eax
	mov dword ptr _ubuf[esi+4], ecx
	add esi, 8
	dec edi
	jnz short beg0_8
	ret
ALIGN 16
beg1_8:
	mov eax, dword ptr _uubuf[esi]
	mov ebx, dword ptr _uubuf[esi+2048]
	mov ecx, dword ptr _uubuf[esi+4]
	mov edx, dword ptr _uubuf[esi+2052]
	lea ebx, [eax*8+ebx]
	add esi, 8
	lea edx, [ecx*8+edx]
	sub ebx, eax
	sub edx, ecx
	mov dword ptr _ubuf[esi-8], ebx
	mov dword ptr _ubuf[esi-4], edx
	dec edi
	jnz short beg1_8
	ret
ALIGN 16
beg2_8:
	mov ebx, dword ptr _uubuf[esi]
	mov eax, dword ptr _uubuf[esi+2048]
	mov edx, dword ptr _uubuf[esi+4]
	mov ecx, dword ptr _uubuf[esi+2052]
	lea eax, [eax*2+ebx]
	lea ebx, [ebx*4+ebx]
	lea ecx, [ecx*2+edx]
	lea edx, [edx*4+edx]
	add eax, ebx
	add ecx, edx
	mov dword ptr _ubuf[esi], eax
	mov dword ptr _ubuf[esi+4], ecx
	add esi, 8
	dec edi
	jnz short beg2_8
	ret
ALIGN 16
beg3_8:
	mov eax, dword ptr _uubuf[esi]
	mov ebx, dword ptr _uubuf[esi+2048]
	mov ecx, dword ptr _uubuf[esi+4]
	mov edx, dword ptr _uubuf[esi+2052]
	lea eax, [eax*4+eax]
	lea ebx, [ebx*2+ebx]
	lea ecx, [ecx*4+ecx]
	lea edx, [edx*2+edx]
	add eax, ebx
	add ecx, edx
	mov dword ptr _ubuf[esi], eax
	mov dword ptr _ubuf[esi+4], ecx
	add esi, 8
	dec edi
	jnz short beg3_8
	ret
ALIGN 16
beg4_8:
	mov eax, dword ptr _uubuf[esi]
	mov ebx, dword ptr _uubuf[esi+2048]
	mov ecx, dword ptr _uubuf[esi+4]
	mov edx, dword ptr _uubuf[esi+2052]
	add eax, ebx
	shl eax, 2
	add ecx, edx
	shl ecx, 2
	mov dword ptr _ubuf[esi], eax
	mov dword ptr _ubuf[esi+4], ecx
	add esi, 8
	dec edi
	jnz short beg4_8
	ret
ALIGN 16
beg5_8:
	mov eax, dword ptr _uubuf[esi]
	mov ebx, dword ptr _uubuf[esi+2048]
	mov ecx, dword ptr _uubuf[esi+4]
	mov edx, dword ptr _uubuf[esi+2052]
	lea eax, [eax*2+eax]
	lea ebx, [ebx*4+ebx]
	lea ecx, [ecx*2+ecx]
	lea edx, [edx*4+edx]
	add eax, ebx
	add ecx, edx
	mov dword ptr _ubuf[esi], eax
	mov dword ptr _ubuf[esi+4], ecx
	add esi, 8
	dec edi
	jnz short beg5_8
	ret
ALIGN 16
beg6_8:
	mov eax, dword ptr _uubuf[esi]
	mov ebx, dword ptr _uubuf[esi+2048]
	mov ecx, dword ptr _uubuf[esi+4]
	mov edx, dword ptr _uubuf[esi+2052]
	lea eax, [eax*2+ebx]
	lea ebx, [ebx*4+ebx]
	lea ecx, [ecx*2+edx]
	lea edx, [edx*4+edx]
	add eax, ebx
	add ecx, edx
	mov dword ptr _ubuf[esi], eax
	mov dword ptr _ubuf[esi+4], ecx
	add esi, 8
	dec edi
	jnz short beg6_8
	ret
ALIGN 16
beg7_8:
	mov ebx, dword ptr _uubuf[esi]
	mov eax, dword ptr _uubuf[esi+2048]
	mov edx, dword ptr _uubuf[esi+4]
	mov ecx, dword ptr _uubuf[esi+2052]
	lea ebx, [eax*8+ebx]
	add esi, 8
	lea edx, [ecx*8+edx]
	sub ebx, eax
	sub edx, ecx
	mov dword ptr _ubuf[esi-8], ebx
	mov dword ptr _ubuf[esi-4], edx
	dec edi
	jnz short beg7_8
	ret
ALIGN 16
beg8_8:
	mov eax, dword ptr _uubuf[esi+2048]
	shl eax, 3
	mov ecx, dword ptr _uubuf[esi+2052]
	shl ecx, 3
	mov dword ptr _ubuf[esi], eax
	mov dword ptr _ubuf[esi+4], ecx
	add esi, 8
	dec edi
	jnz short beg8_8
	ret


ALIGN 16
mmxbeg0_8:
	movq mm0, _uubuf[esi]
	pslld mm0, 3
	movq _ubuf[esi], mm0
	add esi, 8
	dec edi
	jnz short mmxbeg0_8
	emms
	ret
ALIGN 16
mmxbeg1_8:
	movq mm0, _uubuf[esi]
	movq mm1, _uubuf[esi+2048]
	add esi, 8
	psubd mm1, mm0
	pslld mm0, 3
	paddd mm0, mm1
	movq _ubuf[esi-8], mm0
	dec edi
	jnz short mmxbeg1_8
	emms
	ret
ALIGN 16
mmxbeg2_8:
	movq mm0, _uubuf[esi]         ;*6
	movq mm1, _uubuf[esi+2048]    ;*2
	add esi, 8
	psubd mm1, mm0
	pslld mm0, 2
	paddd mm0, mm1
	pslld mm0, 1
	movq _ubuf[esi-8], mm0
	dec edi
	jnz short mmxbeg2_8
	emms
	ret
ALIGN 16
mmxbeg3_8:
	movq mm0, _uubuf[esi]         ;*5
	movq mm1, _uubuf[esi+2048]    ;*3
	add esi, 8
	movq mm2, mm0
	psubd mm2, mm1
	paddd mm0, mm1
	pslld mm0, 2
	paddd mm0, mm2
	movq _ubuf[esi-8], mm0
	dec edi
	jnz short mmxbeg3_8
	emms
	ret
ALIGN 16
mmxbeg4_8:
	movq mm0, _uubuf[esi]
	paddd mm0, _uubuf[esi+2048]
	pslld mm0, 2
	movq _ubuf[esi], mm0
	add esi, 8
	dec edi
	jnz short mmxbeg4_8
	emms
	ret
ALIGN 16
mmxbeg5_8:
	movq mm0, _uubuf[esi]           ;*3
	movq mm1, _uubuf[esi+2048]      ;*5
	add esi, 8
	movq mm2, mm1
	psubd mm2, mm0
	paddd mm0, mm1
	pslld mm0, 2
	paddd mm0, mm2
	movq _ubuf[esi-8], mm0
	dec edi
	jnz short mmxbeg5_8
	emms
	ret
ALIGN 16
mmxbeg6_8:
	movq mm0, _uubuf[esi]         ;*2
	movq mm1, _uubuf[esi+2048]    ;*6
	add esi, 8
	psubd mm0, mm1
	pslld mm1, 2
	paddd mm0, mm1
	pslld mm0, 1
	movq _ubuf[esi-8], mm0
	dec edi
	jnz short mmxbeg6_8
	emms
	ret
ALIGN 16
mmxbeg7_8:
	movq mm0, _uubuf[esi]           ;*1
	movq mm1, _uubuf[esi+2048]      ;*7
	add esi, 8
	psubd mm0, mm1
	pslld mm1, 3
	paddd mm0, mm1
	movq _ubuf[esi-8], mm0
	dec edi
	jnz short mmxbeg7_8
	emms
	ret
ALIGN 16
mmxbeg8_8:
	movq mm0, _uubuf[esi+2048]
	pslld mm0, 3
	movq _ubuf[esi], mm0
	add esi, 8
	dec edi
	jnz short mmxbeg8_8
	emms
	ret


PUBLIC doratioinc_
doratioinc_:
	test edi, 1
	jz short beginc
	mov eax, dword ptr _ubuf-8[esi+edi*8]
	mov ebx, dword ptr _ubuf-4[esi+edi*8]
	mov ecx, dword ptr _uibuf-8[esi+edi*8]
	mov edx, dword ptr _uibuf-4[esi+edi*8]
	add eax, ecx
	add ebx, edx
	mov dword ptr _ubuf-8[esi+edi*8], eax
	mov dword ptr _ubuf-4[esi+edi*8], ebx
	dec edi
	jz short endinc
beginc:
	mov eax, dword ptr _ubuf-8[esi+edi*8]
	mov ebx, dword ptr _ubuf-4[esi+edi*8]
	mov ecx, dword ptr _uibuf-8[esi+edi*8]
	mov edx, dword ptr _uibuf-4[esi+edi*8]
	add eax, ecx
	add ebx, edx
	mov dword ptr _ubuf-8[esi+edi*8], eax
	mov dword ptr _ubuf-4[esi+edi*8], ebx
	mov eax, dword ptr _ubuf-16[esi+edi*8]
	mov ebx, dword ptr _ubuf-12[esi+edi*8]
	mov ecx, dword ptr _uibuf-16[esi+edi*8]
	mov edx, dword ptr _uibuf-12[esi+edi*8]
	add eax, ecx
	add ebx, edx
	mov dword ptr _ubuf-16[esi+edi*8], eax
	mov dword ptr _ubuf-12[esi+edi*8], ebx
	sub edi, 2
	jnz short beginc
endinc:
	ret
mmxdoratioinc:
	test edi, 1
	jz short mmxbeginc
	movq mm0, _ubuf-8[esi+edi*8]
	paddd mm0, _uibuf-8[esi+edi*8]
	movq _ubuf-8[esi+edi*8], mm0
	dec edi
	jz short mmxendinc
mmxbeginc:
	movq mm0, _ubuf-8[esi+edi*8]
	movq mm1, _ubuf-16[esi+edi*8]
	paddd mm0, _uibuf-8[esi+edi*8]
	paddd mm1, _uibuf-16[esi+edi*8]
	movq _ubuf-8[esi+edi*8], mm0
	movq _ubuf-16[esi+edi*8], mm1
	sub edi, 2
	jnz short mmxbeginc
mmxendinc:
	emms
	ret

	;     Pass:             Use:
	;eax: [d]
	;ebx: [u]
	;ecx: [v]
	;edx: ?
	;esi: x1                x
	;edi: x2                cursh0
	;ebp: -                 cursh1
	;esp: -
PUBLIC getubufasm1_
getubufasm1_:
	fld dword ptr [ecx]                    ;v
	fld dword ptr [ebx]                    ;u,v
	fld dword ptr [eax]                    ;d,u,v
	fld dword ptr [num1048576]             ;1048576,d,u,v
	fdiv st, st(1)                         ;1048576/d,d,u,v
getubufbeg1:
	fld st(3)                              ;v,1048576/d,d,u,v
	fadd dword ptr [_fgvxx]                ;v+vi,1048576/d,d,u,v
	fxch st(4)                             ;v,1048576/d,d,u,v+vi
	fmul st, st(1)                         ;v*1048576/d,1048576/d,d,u,v+vi
	fxch st(1)                             ;1048576/d,v*1048576/d,d,u,v+vi
	fmul st, st(3)                         ;u*1048576/d,v*1048576/d,d,u,v+vi
	fxch st(1)                             ;v*1048576/d,u*1048576/d,d,u,v+vi
	fistp dword ptr _uubuf+4[esi*4]        ;u*1048576/d,d,u,v+vi
	fistp dword ptr _uubuf[esi*4]          ;d,u,v+vi
	fadd dword ptr [_fgdxx]                ;d+di,u,v+vi
	fxch st(1)                             ;u,d+di,v+vi
	fadd dword ptr [_fguxx]                ;u+ui,d+di,v+vi
	fxch st(1)                             ;d+di,u+ui,v+vi
	fld dword ptr [num1048576]             ;1048576,d+di,u+ui,v+vi
	fdiv st, st(1)                         ;1048576/(d+di),d+di,u+ui,v+vi

	mov eax, dword ptr _uubuf[esi*4]
	mov ebx, dword ptr _uubuf+4[esi*4]
	mov ecx, dword ptr _uubuf+2048[esi*4]
	mov edx, dword ptr _uubuf+2052[esi*4]
	sub eax, ecx
	sub ebx, edx
	mov dword ptr _uibuf[esi*4], eax
	mov dword ptr _uibuf+4[esi*4], ebx
	add esi, 2
	cmp esi, edi
	jbe short getubufbeg1

	fcompp                                 ;d,u,v
	fcompp                                 ;v
	ret


	;     Pass:             Use:
	;eax: [d]
	;ebx: [u]
	;ecx: [v]
	;edx: ?
	;esi: x1                x
	;edi: x2                cursh0
	;ebp: -                 cursh1
	;esp: -
PUBLIC getubufasm2_
getubufasm2_:
	fld dword ptr [ecx]                    ;v
	fld dword ptr [ebx]                    ;u,v
	fld dword ptr [eax]                    ;d,u,v
	fld dword ptr [num1048576]             ;1048576,d,u,v
	fdiv st, st(1)                         ;1048576/d,d,u,v
getubufbeg2:
	fld st(3)                              ;v,1048576/d,d,u,v
	fadd dword ptr [_fgvxx]                ;v+vi,1048576/d,d,u,v
	fxch st(4)                             ;v,1048576/d,d,u,v+vi
	fmul st, st(1)                         ;v*1048576/d,1048576/d,d,u,v+vi
	fxch st(1)                             ;1048576/d,v*1048576/d,d,u,v+vi
	fmul st, st(3)                         ;u*1048576/d,v*1048576/d,d,u,v+vi
	fxch st(1)                             ;v*1048576/d,u*1048576/d,d,u,v+vi
	fistp dword ptr _uubuf+2052[esi*4]     ;u*1048576/d,d,u,v+vi
	fistp dword ptr _uubuf+2048[esi*4]     ;d,u,v+vi
	fadd dword ptr [_fgdxx]                ;d+di,u,v+vi
	fxch st(1)                             ;u,d+di,v+vi
	fadd dword ptr [_fguxx]                ;u+ui,d+di,v+vi
	fxch st(1)                             ;d+di,u+ui,v+vi
	fld dword ptr [num1048576]             ;1048576,d+di,u+ui,v+vi
	fdiv st, st(1)                         ;1048576/(d+di),d+di,u+ui,v+vi

	mov eax, dword ptr _uubuf+2048[esi*4]
	mov ebx, dword ptr _uubuf+2052[esi*4]
	mov ecx, dword ptr _uubuf[esi*4]
	mov edx, dword ptr _uubuf+4[esi*4]
	sub eax, ecx
	sub ebx, edx
	mov dword ptr _uibuf[esi*4], eax
	mov dword ptr _uibuf+4[esi*4], ebx
	add esi, 2
	cmp esi, edi
	jbe short getubufbeg2

	fcompp                                 ;d,u,v
	fcompp                                 ;v
	ret


PUBLIC prommxoverlays_
prommxoverlays_:
	pushfd                 ;Check if CPUID is available
	pop eax
	mov ebx, eax
	xor eax, 00200000h
	push eax
	popfd
	pushfd
	pop eax
	cmp eax, ebx
	je pentium
	xor eax, eax
	dw 0a20fh
	test eax, eax
	jz pentium
	mov eax, 1
	dw 0a20fh
	and eax, 00000f00h
	test edx, 00800000h    ;Check if MMX is available
	jz nommx
	cmp eax, 00000600h     ;Check if P6 Family or not
	jae pentiumii
	jmp pentiummmx
nommx:
	cmp eax, 00000600h     ;Check if P6 Family or not
	jae pentiumpro
pentium:
	ret

;Ŀ
;                    PENTIUM II Overlays                       
;
pentiumii:
		;Any specific PENTIUM II Overlays go here
	call pentiumpro
		;Note: code falls through into PENTIUM MMX Overlays

;Ŀ
;                    PENTIUM MMX Overlays                      
;
pentiummmx:
		;Got MMX if here
	mov dword ptr [doratiojmptable+0], offset mmxbeg0_8
	mov dword ptr [doratiojmptable+4], offset mmxbeg1_8
	mov dword ptr [doratiojmptable+8], offset mmxbeg2_8
	mov dword ptr [doratiojmptable+12], offset mmxbeg3_8
	mov dword ptr [doratiojmptable+16], offset mmxbeg4_8
	mov dword ptr [doratiojmptable+20], offset mmxbeg5_8
	mov dword ptr [doratiojmptable+24], offset mmxbeg6_8
	mov dword ptr [doratiojmptable+28], offset mmxbeg7_8
	mov dword ptr [doratiojmptable+32], offset mmxbeg8_8
	mov dword ptr [doratiojmptable+36], offset mmxbeg7_8
	mov dword ptr [doratiojmptable+40], offset mmxbeg6_8
	mov dword ptr [doratiojmptable+44], offset mmxbeg5_8
	mov dword ptr [doratiojmptable+48], offset mmxbeg4_8
	mov dword ptr [doratiojmptable+52], offset mmxbeg3_8
	mov dword ptr [doratiojmptable+56], offset mmxbeg2_8
	mov dword ptr [doratiojmptable+60], offset mmxbeg1_8
		;Modify jmp short mmxdoratioinc  0xe9 + dword(mmxdoratioinc-doratioinc-5)
	mov byte ptr [doratioinc_], 0xe9
	mov dword ptr [doratioinc_+1], (offset mmxdoratioinc)-(offset doratioinc_)-5
	ret

;Ŀ
;                    PENTIUM PRO Overlays                      
;
pentiumpro:
	mov byte ptr [setupkspin_], 0xe9      ;setupkspin: jmp prosetupkspin
	mov dword ptr [setupkspin_+1], (offset prosetupkspin_)-(offset setupkspin_)-5
	mov byte ptr [kspin_], 0xe9           ;kspin: jmp prokspin
	mov dword ptr [kspin_+1], (offset prokspin_)-(offset kspin_)-5
	mov byte ptr [kspinshort_], 0xe9      ;kspinshort: jmp prokspinshort
	mov dword ptr [kspinshort_+1], (offset prokspinshort_)-(offset kspinshort_)-5
	ret



CODE ENDS
END
